//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// Z poniższym kodem nie jest związana żadna gwarancja poprawności działania.
// Program został dołączony do książki ".NET CLR. Księga eksperta" w celu
// ilustracji koncepcji i zasad przedstawionych w tej książce. Program może być 
// używany na własne ryzyko.
//
// Przyznaje się prawo do użycia lub kopiowania tego oprogramowania do dowolnego celu
// bez konieczności ponoszenia żadnych opłat pod warunkiem, że powyższe uwagi zostaną 
// zachowane we wszystkich kopiach. Przyznaje się także prawo do modyfikacji kodu
// i dystrybucji zmodyfikowanego kodu pod warunkiem zachowania powyższych uwag
// oraz dołączenia informacji mówiącej o modyfikacji kodu.
//
// 
using System;
using System.Threading;

namespace ThreadHelloWorld
{
	class HelloWorld
	{
		private string message;
		public string Message
		{
			get
			{
				return message;
			}
			set
			{
				message = value;
			}
		}
		public void ThreadEntry()
		{
			Console.WriteLine(message);
		}
	}
	class DynamicThreadInformation
	{
		static void Main(string[] args)
		{
			HelloWorld first = new HelloWorld();
			first.Message = "Witaj świecie z pierwszego egzemplarza!";
			HelloWorld second = new HelloWorld();
			second.Message = "Witaj świecie z drugiego egzemplarza!";
			ThreadStart tsd = new ThreadStart(first.ThreadEntry);
			tsd += new ThreadStart(second.ThreadEntry);
			Thread t = new Thread(tsd);
			t.Start();
			t.Join();
		}
	}
}
